﻿using System.Collections.ObjectModel;
using WpfTreeView.Model;
using WpfTreeView.Provider;

namespace WpfTreeView.ViewModel
{
    public class MainWindowViewModel : ViewModelBase
    {
        private readonly IMemoryDataProvider _dataProvider;

        public MainWindowViewModel()
        {
            _dataProvider = new MemoryDataProvider();
            LoadArticleMasters();
        }

        private ObservableCollection<ArticleMaster> _masters;
        public ObservableCollection<ArticleMaster> Masters { get => _masters; set => SetValue(ref _masters, value); }

        private object _selectedObject;
        public object SelectedObject { get => _selectedObject; set => SetValue(ref _selectedObject, value); }

        private bool _isSelected;
        public bool IsSelected 
        { 
            get => _isSelected;
            set
            {
                if (SetValue(ref _isSelected, value))
                    SelectedObject = this;
            }
        }


        private void LoadArticleMasters()
        {
            var list = _dataProvider.GetArticleMasters();
            Masters = new ObservableCollection<ArticleMaster>();
            list.ForEach(m => Masters.Add(m));
        }
    }
}
